﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.Misc;
using System.Text.RegularExpressions;

namespace ValidatorCustomConditions
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ValidationSettings text1Settings = ultraValidator1.GetValidationSettings(ultraTextEditor1);
            text1Settings.Condition = new CustomCondition();
            text1Settings.IsRequired = true;

            ValidationSettings text2Settings = ultraValidator1.GetValidationSettings(ultraTextEditor2);
            text2Settings.Condition = new CustomCondition();
            text2Settings.IsRequired = true;

            ultraValidator1.Validate(true, false);
        }

        private void ultraTextEditor1_Validated(object sender, EventArgs e)
        {
            EnableOKButton();
        }

        private void ultraTextEditor2_Validated(object sender, EventArgs e)
        {
            EnableOKButton();
        }

        private void EnableOKButton()
        {
            // The simplest way to verify that each control is valid is to validate everything here, since the controls
            // don't keep track of whether they are in a 'validated' state, and there is no list of 'controls to validate.'
            if (ultraValidator1.Validate(false, false).IsValid)
                ultraButton1.Enabled = true;
        }

        private void ultraValidator1_ValidationError(object sender, ValidationErrorEventArgs e)
        {
            ultraButton1.Enabled = false;
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }

    public class CustomCondition : ICondition
    {
        public bool Matches(object value, IConditionContextProvider contextProvider)
        {
            // This regular expression looks for strings formatted like a case number
            string formatString = "^CAS-[0-9]{5}-[A-Z]{6}$";    //CAS-00000-AAAAAA
            Regex reg = new Regex(formatString);
            
            if (reg.IsMatch(value as string))
            {
                // This regular expression looks for strings containing 'ASDF'
                string characterString = "ASDF";
                reg = new Regex(characterString);
                return reg.IsMatch(value as string);
            }

            return false;
        }

        public event EventHandler PropertyChanged;

        public object Clone()
        {
            throw new NotImplementedException();
        }
    }

}
